(*
    LCS - A study for a simple differencing program
    Options window
    Copyright (c) 2002-2003 Alessandro Scotti
    http://www.ascotti.org/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)
unit FormOptions;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,
  DiffFileEngine;

type
  TAppOptions = record
    DiffOptions: TDiffOptions;
    BackupSavedFiles: boolean;
    TabSize: integer;
    MaximizeWindow: boolean;
    DblClickOnRightFileDeletes: boolean;
  end;

type
  TOptionsForm = class(TForm)
    Label1: TLabel;
    edtTabSize: TEdit;
    Button1: TButton;
    Button2: TButton;
    chkBackupSavedFiles: TCheckBox;
    chkIgnoreBlanks: TCheckBox;
    ChkMaximizeWindow: TCheckBox;
    grpRightDblClick: TGroupBox;
    radCopyOnDblClickRight: TRadioButton;
    radDeleteOnDblClickRight: TRadioButton;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
    FOptions: TAppOptions;
  public
    { Public declarations }
    procedure SetOptions( const Options: TAppOptions );
    procedure GetOptions( var Options: TAppOptions );
  end;

var
  OptionsForm: TOptionsForm;

implementation

{$R *.DFM}

procedure TOptionsForm.SetOptions( const Options: TAppOptions );
begin
  FOptions := Options;
  edtTabSize.Text := IntToStr(Options.TabSize);
  chkBackupSavedFiles.Checked := Options.BackupSavedFiles;
  chkIgnoreBlanks.Checked := Options.DiffOptions.IgnoreBlanks;
  chkMaximizeWindow.Checked := FOptions.MaximizeWindow;
  radCopyOnDblClickRight.Checked := not FOptions.DblClickOnRightFileDeletes;
  radDeleteOnDblClickRight.Checked := FOptions.DblClickOnRightFileDeletes;
end;

procedure TOptionsForm.GetOptions( var Options: TAppOptions );
begin
  Options := FOptions;
end;

procedure TOptionsForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  try
    FOptions.TabSize := StrToInt( edtTabSize.Text );
    FOptions.DiffOptions.IgnoreBlanks := chkIgnoreBlanks.Checked;
    FOptions.BackupSavedFiles := chkBackupSavedFiles.Checked;
    FOptions.MaximizeWindow := chkMaximizeWindow.Checked;
    FOptions.DblClickOnRightFileDeletes := radDeleteOnDblClickRight.Checked;
  except
    CanClose := false;
    MessageBox( Handle, 'Invalid option value(s)', 'Options', MB_OK or MB_ICONERROR );
  end;
end;

end.
